//+------------------------------------------------------------------+
//|                                                    SandyEw-1.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs

extern bool use.timeLocal          = false;
extern bool use.onLineChart        = true;
extern bool use.nonLinearTime      = false;  

int main.cnt;
extern string symbol.name          = "-1";
extern datetime start.time =D'2012.10.25 14:18';

int hand1e, MT4InternalMsg = 0;

#include <WinUser32.mqh>
#include <stdlib.mqh>
 
#import  "user32.dll"
	int   RegisterWindowMessageA(string lpString); 
#import

 
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int cicle.ms = 10;

int start()
  {
//----
    if(IsDllsAllowed()==false) 
    {
	 Print("Error: Dll calls must be allowed!");
	 return(-1);
    }	
//----	
    if(symbol.name == "-1"){
    symbol.name = {StringConcatenate("tick",Symbol())};
    }
    else{
    if(StringLen(symbol.name)>12){
    Print("Error: Too long name of symbol!");
    return(-1);
     }
    }
//----    	
    hand1e ={ FileOpen(  StringConcatenate(symbol.name, 1, ".hst"), FILE_BIN|FILE_READ  ) };
    
    if(hand1e>0){
    
    Sleep(50);
    
    FileClose(hand1e);
    
    Sleep(50);
   
    hand1e ={ FileOpenHistory( StringConcatenate(symbol.name, 1, ".hst"), FILE_BIN|FILE_READ | FILE_WRITE) };
 
    
    }
    else{
    hand1e ={ FileOpenHistory( StringConcatenate(symbol.name, 1, ".hst"), FILE_BIN|FILE_READ | FILE_WRITE) };
    
    Sleep(50); 
//----
		int unused[13];
		FileWriteInteger(hand1e, 400, LONG_VALUE); 			 
		FileWriteString (hand1e, "", 64);				 
		FileWriteString (hand1e, symbol.name, 12); 
		FileWriteInteger(hand1e, 1, LONG_VALUE);	 
		FileWriteInteger(hand1e, Digits, LONG_VALUE);		 
		FileWriteInteger(hand1e, 0, LONG_VALUE);		  
		FileWriteInteger(hand1e, 0, LONG_VALUE);		 
		FileWriteArray  (hand1e, unused, 0, 13);			 
    }
//----    
int time;
    while(IsStopped()==false)
    {

    Sleep(cicle.ms);
   //---------------------- 
       if(use.timeLocal == true)
       {
       time={ TimeLocal  () };
       }
       else{
       time={ TimeCurrent() };
       }
           
       if(time>start.time)
       {    
 //-------    
    Comment( StringConcatenate(WindowExpertName()," ",TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS),"  Recording...","\n",main.cnt," ticks") );
    
    if(event.tick()>0)
      {
      refresh.data();
      }
      else
      {
      continue;
      }   
    }
    else{ 
    Comment( StringConcatenate(WindowExpertName()," ",TimeToStr((start.time-time),TIME_MINUTES|TIME_SECONDS),"  Remain...") );
     }
    }
//----
   FileClose(hand1e);
   Comment(""); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| script update tick chart function                                |
//+------------------------------------------------------------------+
void update.chart.window() {
	static int hwnd = 0;
 
	if(hwnd == 0) {
		hwnd = WindowHandle(symbol.name, 1);
		if(hwnd != 0) Print("Chart window detected"); 
	}

	if(use.onLineChart && MT4InternalMsg == 0) 
		MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");

	if(hwnd != 0) if(PostMessageA(hwnd, WM_COMMAND, 0x822c, 0) == 0) hwnd = 0;
	if(hwnd != 0 && MT4InternalMsg != 0) PostMessageA(hwnd, MT4InternalMsg, 2, 1);

	return;
}
//+------------------------------------------------------------------+
//| script write data function                                       |
//+------------------------------------------------------------------+
int refresh.data()
  {
//----

double vol,ask,bid = 0.0;
   int time,sec = 0;
static datetime t =0; static datetime lt =0;

       RefreshRates();
         
       ask ={Ask};
       bid ={Bid};
      
       if(use.timeLocal == true)
       {
       time={ TimeLocal  () };
       }
       else{
       time={ TimeCurrent() };
       }
       
      
//----
       sec ={ TimeSeconds(time) };
//----       
       if(use.nonLinearTime == false)
       {   
		 if(t < time){ t ={time}; } 
       }
       else{
		 if(t < time){ t ={time}; }
		 else{ 
		 t++;
		 }     
       }
//----     

 FileSeek(hand1e,0,2);

//----
		FileWriteInteger(hand1e,    t,   LONG_VALUE);		 
		FileWriteDouble (hand1e,  bid, DOUBLE_VALUE);          
		FileWriteDouble (hand1e,  bid, DOUBLE_VALUE);		 
		FileWriteDouble (hand1e,  ask, DOUBLE_VALUE);	 
		FileWriteDouble (hand1e,  bid, DOUBLE_VALUE);				 
		FileWriteDouble (hand1e,  sec, DOUBLE_VALUE);	 		
            FileFlush (hand1e);       
                        
//----   
       if(use.onLineChart == true)
       {
       update.chart.window();
       }
//---- 
return;
}   
//+------------------------------------------------------------------+
//| script event viewer watching function                            |
//+------------------------------------------------------------------+
int event.tick()
  {
//----
static double askS;
static double bidS;

       RefreshRates(); 
        
       double bidC = Bid;
       double askC = Ask;
              
if(( (askS == 0) || !(askS == askC) ) || ( (bidS == 0) || !(bidS == bidC) ))
  {

 askS ={ askC };
 bidS ={ bidC };
 main.cnt++;
 return(1);
 }
 else{

 return(0);
 
 } 
}
//+------------------------------------------------------------------+
 